#include "CamOpenGL.h"
#include "Scene.h"
#include "Light.h"
#include "Triangle.h"
#include "Shape.h"
#include "Shader.h"
#include "Tessellation.h"
#include "glut.h"

CamOpenGL *curOGLCam;

CamOpenGL::CamOpenGL() : tess( NULL )
{
}

CamOpenGL::~CamOpenGL()
{
	if( tess ) {
		delete tess;
	}
}

void CamOpenGL::preProcess( Scene& scene )
{
/*	List<Face> *initialTess = NULL;
	int argc = 1;
	char *argv[1];
	argv[0] = new char[10];
	strcpy( argv[0], "bogus" );

	// set up window 
	glutInitWindowSize( (int)imageRes[VX], (int)imageRes[VY] );
	glutInitDisplayMode( GLUT_SINGLE | GLUT_DEPTH );
	glutInit( &argc, argv );
	glutCreateWindow( "OpenGL Camera" );
	glutDisplayFunc( displayOGL );

	glEnable( GL_DEPTH_TEST );
	glDepthFunc( GL_LEQUAL );

	glShadeModel( GL_SMOOTH );
	glEnable( GL_NORMALIZE );

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	// set up lighting 
	glEnable( GL_LIGHTING );
	for( int curLight = 0; curLight < scene.lightList.size(); curLight++ ) {

		int oglLight = GL_LIGHT0 + curLight;
		GLfloat origin[] = {0.0,0.0,0.0,1.0};
		GLfloat tform[16];
		float vec[4];
		Light*& light = scene.lightList[curLight];

		light->getCtransform().asFloat( tform );
		glLoadMatrixf( tform );

		glEnable( oglLight );
		light->ambientColor().asFloat( vec );
		glLightfv( oglLight, GL_AMBIENT, vec );

		light->diffuseColor().asFloat( vec );
		glLightfv( oglLight, GL_DIFFUSE, vec );

		light->specularColor().asFloat( vec );
		glLightfv( oglLight, GL_SPECULAR, vec );

		glLightfv( oglLight, GL_POSITION, origin );
	}

	GLfloat tform[16];

	// set up perspective transform 
	projTform.asFloat( tform );
	glMatrixMode( GL_PROJECTION );
	glLoadMatrixf( tform );

	// set up viewing transform 
	glMatrixMode( GL_MODELVIEW );
	viewTform.asFloat(tform);
	glLoadMatrixf( tform );

	// set up scene and camera pointers 
	scenePtr = &scene; 
	curOGLCam = this;
*/
}

void CamOpenGL::render( Scene& scene )
{
	glutMainLoop();
}

void CamOpenGL::interactiveRender( )
{
	int numObjects = scenePtr->objList.size();

	for( int i = 0; i < numObjects; i++ ) {
		Shape *&curObject = scenePtr->objList[i];

		curObject->getShader()->setupOGL();
//		curObject->renderOGL();
		glFlush();
	}
}

void CamOpenGL::postProcess( Scene& scene )
{
}

void CamOpenGL::write( ostream& s ) 
{
}

bool CamOpenGL::read( istream& s )
{
	if( !Cam::read( s ) ) {
		return false;
	}

	return true;
}