#ifndef CamOpenGL_h
#define CamOpenGL_h

#include "Cam.h"

class Scene;
class Face;
class Triangle;
class Tessellation;

/* CamOpenGL is an OpenGL rendering camera */

class CamOpenGL : public Cam
{
public:
	CamOpenGL();
	virtual ~CamOpenGL();

	void preProcess( Scene& scene );
	void render( Scene& scene );
	void postProcess( Scene& scene );

	void interactiveRender();

	virtual bool read( istream& s );
	virtual void write( ostream& s );

protected:

	Tessellation *tess;
	int windowID;
	Scene *scenePtr;

};

#endif