#include "Checker2D.h"
#include "Sample.h"
#include "Scene.h"

//
//  Attribute index definitions
//
int Checker2D::kColor1;
int Checker2D::kColor2;
int Checker2D::kWidth;

//
//  Constructor initializes attributes for this instance
//
Checker2D::Checker2D()
{
	Checker2D::initializeAttributes();
}

//
//  Attribute initialization
//
void Checker2D::initializeAttributes()
{
	Texture2D::initializeAttributes();

	kColor1 = addAttr( new AttributeVec3( "color1", TEXTURABLE, vec3(0.0) ) );
	kColor2 = addAttr( new AttributeVec3( "color2", TEXTURABLE, vec3(1.0) ) );
	kWidth = addAttr( new AttributeDouble( "width", TEXTURABLE, 0.0 ) );
}

//
//  Evaluate the color.  Use the scalar texture value to blend 
//  between color1 and color2.
//
vec3 Checker2D::vector() 
{
	double val = scalar();
	return val*attrColor1() + (1.0-val)*attrColor2();
}

//
//	Evaluate the scalar value of the texture
//
double Checker2D::scalar()
{
	Sample& sample = Attribute::curSample();
	vec2& tex = fTransform * sample.texCoords2d;

	int x = fastDblToInt(floor(tex[VX]));
	int y = fastDblToInt(floor(tex[VY]));

	if( (x+y)%2 == 0 ) {
		return 0.0;
	} else {
		return 1.0;
	}
}



