#ifndef Checker2D_h
#define Checker2D_h

#include "Texture2D.h"

/****************************************************************

	Class:		Checker2D
	Purpose:	2d checker texture.	

*****************************************************************/
class Checker2D : public Texture2D
{
public:

	Checker2D();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kColor1;		// one color
	static int kColor2;		// other color
	static int kWidth;		// blend width for antialiasing

	// attribute accessors
	vec3& attrColor1() { return findAttr(kColor1)->asVec3(); };
	vec3& attrColor2() { return findAttr(kColor2)->asVec3(); };
	double& attrWidth() { return findAttr(kWidth)->asDouble(); };

	// computation methods
	virtual vec3 vector();
	virtual double scalar();
};

#endif