#include "Checker3D.h"
#include "Sample.h"
#include "Scene.h"

//
//  Attribute index definitions
//
int Checker3D::kColor1;
int Checker3D::kColor2;
int Checker3D::kWidth;

//
//  Constructor just initializes the attributes for this class
//
Checker3D::Checker3D()
{
	Checker3D::initializeAttributes();
}

//
//  Attribute initialization
//
void Checker3D::initializeAttributes()
{
	Texture3D::initializeAttributes();

	kColor1 = addAttr( new AttributeVec3( "color1", TEXTURABLE, vec3(0.0) ) );
	kColor2 = addAttr( new AttributeVec3( "color2", TEXTURABLE, vec3(1.0) ) );
	kWidth = addAttr( new AttributeDouble( "width", TEXTURABLE, 0.0 ) );
}

//
//  Vector compute method - use the scalar value to blend between colors
//
vec3 Checker3D::vector() 
{
	double val = scalar();
	return val*attrColor1() + (1.0-val)*attrColor2();
}

//
//  Evaluate scalar value
//
double Checker3D::scalar()
{
	Sample& sample = Attribute::curSample();
	vec3& tex = fTransform * sample.texCoords3d;

	int x = fastDblToInt(floor(tex[VX]));
	int y = fastDblToInt(floor(tex[VY]));
	int z = fastDblToInt(floor(tex[VZ]));

	if( (x+y+z)%2 == 0 ) {
		return 0.0;
	} else {
		return 1.0;
	}
}


