#ifndef Checker3D_h
#define Checker3D_h

#include "Texture3D.h"

/****************************************************************

	Class:		Checker3D
	Purpose:	3d checker texture.	

*****************************************************************/
class Checker3D : public Texture3D
{
public:

	Checker3D();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kColor1;		// one color
	static int kColor2;		// other color
	static int kWidth;		// blend width for antialiasing

	// attribute accessors
	vec3& attrColor1() { return findAttr(kColor1)->asVec3(); };
	vec3& attrColor2() { return findAttr(kColor2)->asVec3(); };
	double attrWidth() { return findAttr(kWidth)->asDouble(); };

	// texture compute methods
	virtual vec3 vector();
	virtual double scalar();
};

#endif