#include "Cube.h"


Cube::Cube()
: Poly()
{
}



bool Cube::read( istream& s )
{
	if( !Shape::read( s ) ) {
		return false;
	}

	List<vec3>& objPoints = attrObjPoints();
	IntListList& faceList = attrFaceList();

	int faces[32] = {0,1,2,3,	// Z = 1
					 7,6,5,4,	// Z = -1
					 1,5,6,2,	// X = 1
					 0,3,7,4,	// X = -1
					 3,2,6,7,	// Y = 1
					 4,5,1,0	// Y = -1
	};

	objPoints.append( vec3( -1.0, -1.0, 1.0 ) );
	objPoints.append( vec3( 1.0, -1.0, 1.0 ) );
	objPoints.append( vec3( 1.0, 1.0, 1.0 ) );
	objPoints.append( vec3( -1.0, 1.0, 1.0 ) );
	objPoints.append( vec3( -1.0, -1.0, -1.0 ) );
	objPoints.append( vec3( 1.0, -1.0, -1.0 ) );
	objPoints.append( vec3( 1.0, 1.0, -1.0 ) );
	objPoints.append( vec3( -1.0, 1.0, -1.0 ) );

	for( int face = 0; face < 6; face++ ) {
		faceList.addList( &faces[4*face], 4 );
	}

	return true;
}

void Cube::write( ostream& s )
{
}