#ifndef FileTexture2D_h
#define FileTexture2D_h

#include "Texture2D.h"

/****************************************************************

	Class:		FileTexture2D
	Purpose:	2d file texture.  Files must be in PPM format.	

*****************************************************************/
class FileTexture2D : public Texture2D
{
public:

	FileTexture2D();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kImageName;		// name of the image file
	
	// attribute accessors
	char *attrImageName() { return findAttr(kImageName)->asString(); };

	// reads in the image
	virtual bool postReadFunc( const Scene& scene );

	// texture compute methods
	virtual vec3 vector();
	virtual double scalar();

protected:

	vec3 *image;				// the actual texture image
	int imageResU, imageResV;	// resolution of the texture image
};

#endif
