#include "FlatShader.h"
#include "Sample.h"
#include "Texture.h"
#include "Scene.h"
#include "glut.h"

//
//  Attribute index definitions
//
int FlatShader::kColor;
int FlatShader::kTransparency;


//
//  Constructor just initializes attributes
//
FlatShader::FlatShader()
{
	FlatShader::initializeAttributes();
}

//
//  Attribute initialization
//
void FlatShader::initializeAttributes()
{
	Shader::initializeAttributes();

	kColor = addAttr( new AttributeVec3( "color", TEXTURABLE, vec3(0.7) ) );
	kTransparency = addAttr( new AttributeVec3( "transparency", TEXTURABLE, vec3(0.0) ) );
}

//
//  Just evaluate color attribute
//
vec3 FlatShader::computeColor( List<Light *>& lights )
{
	return attrColor();
}

//
//  Just evaluate transparency attribute 
//
vec3 FlatShader::computeTransparency()
{
	return attrTransparency();
}

//
//	Don't know how to make shader ignore lighting in OpenGL
//
void FlatShader::setupOGL()
{
	GLfloat vec[4];
	vec3 col = attrColor();
	col.asFloat(vec);
	glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, vec );
}

