#ifndef FlatShader_h
#define FlatShader_h

#include "Shader.h"

/****************************************************************

	Class:		FlatShader
	Purpose:	Constant color, constant transparency shader	

*****************************************************************/

class FlatShader : public Shader
{
public:
	FlatShader();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kColor;			// constant color
	static int kTransparency;	// constant transparency

	// attribute accessors
	vec3& attrColor() { return findAttr(kColor)->asVec3(); };
	vec3& attrTransparency() { return findAttr(kTransparency)->asVec3(); };

	// transparency/color compute methods
	virtual vec3 computeColor( List<Light *>& lights );
	virtual vec3 computeTransparency();

	// OpenGL material state method
	virtual void setupOGL();

};

#endif