#include "Lerp.h"


//
//	Initialize current and delta values
//
LerpVec3::LerpVec3( vec3& start, vec3& end, vec2& range ) 
{
	currentVal = start;
	if( range[1] == range[0] ) { 
		deltaVal = vec3(0.0);
	} else {
		deltaVal = (end - start) / (range[1] - range[0]);
	}
}


//
//	Initialize current and delta values
//
LerpVec3::LerpVec3( vec3& start, vec3& delta ) :
	currentVal(start), deltaVal(delta)
{
}

//
//	Gets current value
//
vec3 LerpVec3::current(void)
{
	return currentVal;
}


//
//	Increments current value by 1 delta
//
void LerpVec3::increment(void)
{
	currentVal += deltaVal;
}


//
//	Increments current value by 'factor' deltas
//
void LerpVec3::increment(double factor)
{
	currentVal += factor*deltaVal;
}
