#ifndef Lerp_h
#define Lerp_h

#include "algebra3.h"


/****************************************************************

	Class:		LerpVec3
	Purpose:	Class for doing linear interpolation of vec3 
				quantities.

*****************************************************************/

class LerpVec3 {
public:

	// default constructor
	LerpVec3() {};

	// interpolates between 'start' and 'end' over 'range'
	LerpVec3( vec3& start, vec3& end, vec2& range );

	// interpolates from 'start' by 'delta'
	LerpVec3( vec3& start, vec3& delta );

	// gets current value of interpolator
	vec3 current(void);

	// increments by delta=1
	void increment(void);

	// increments by some other delta
	void increment(double factor);

private:
	vec3 currentVal;	// current interpolation value
	vec3 deltaVal;		// delta value
};


#endif