#include "Light.h"
#include <string.h>

//
//  Attribute index definitions
//
int Light::kAmbient;
int Light::kDiffuse;
int Light::kSpecular;

//
//  Constructor just initializes attributes
//
Light::Light()
{
	Light::initializeAttributes();
}

//
//  Attribute initialization
//
void Light::initializeAttributes()
{
	Model::initializeAttributes();

	kAmbient = addAttr( new AttributeVec3( "ambient", ANIMATABLE, vec3(1.0) ) );
	kDiffuse = addAttr( new AttributeVec3( "diffuse", ANIMATABLE, vec3(1.0) ) );
	kSpecular = addAttr( new AttributeVec3( "specular", ANIMATABLE, vec3(1.0) ) );
}

//
//  Updates the transformation matrix and computes the world position
//  of the light source (we do shading in world space)
//
void Light::updateTransform()
{
	Model::updateTransform();

	fWorldPos = cumulativeTform * vec4(0.0,0.0,0.0,1.0);
}

