#ifndef ListNonTem_h
#define ListNonTem_h

#define MdeclareList(TYPE,NAME)											\
class NAME;																\
class Chunk##NAME														\
{																		\
public:																	\
	Chunk##NAME( int size = 10, Chunk##NAME *next = NULL );				\
	~Chunk##NAME();														\
																		\
	friend class NAME;													\
private:																\
	TYPE* chunk;														\
	Chunk##NAME *next;													\
};																		\
																		\
																		\
class NAME																\
{																		\
public:																	\
	NAME( int chunkSize = 10 );											\
	~NAME();															\
																		\
	TYPE& operator[]( int index );										\
	void append( const TYPE& newElement );								\
	TYPE& append();														\
	int size(void);														\
	void resize( int newSize );											\
	NAME& operator=( const NAME& rhs );									\
																		\
	int find( char *name, int (*compFunc)(TYPE&, const char *) );		\
																		\
	friend ostream& operator<<( ostream& s, NAME& l );					\
																		\
private:																\
	Chunk##NAME *chunks;												\
	Chunk##NAME *lastChunk;												\
																		\
	int chunkSize;														\
	int numChunks;														\
	int lastIndex;														\
																		\
};																		

#define MdeclarePList(TYPE,NAME)										\
class NAME;																\
class Chunk##NAME														\
{																		\
public:																	\
	Chunk##NAME( int size = 10, Chunk##NAME *next = NULL );				\
	~Chunk##NAME();														\
																		\
	friend class NAME;													\
private:																\
	TYPE** chunk;														\
	Chunk##NAME *next;													\
};																		\
																		\
																		\
class NAME																\
{																		\
public:																	\
	NAME( int chunkSize = 10 );											\
	~NAME();															\
																		\
	TYPE*& operator[]( int index );										\
	void append( const TYPE* newElement );								\
	TYPE*& append();													\
	int size(void);														\
	void resize( int newSize );											\
	NAME& operator=( const NAME& rhs );									\
																		\
	int find( char *name, int (*compFunc)(TYPE*, const char *) );		\
																		\
	friend ostream& operator<<( ostream& s, NAME& l );					\
																		\
private:																\
	Chunk##NAME *chunks;												\
	Chunk##NAME *lastChunk;												\
																		\
	int chunkSize;														\
	int numChunks;														\
	int lastIndex;														\
																		\
};																	

#define MimplementList(TYPE,NAME)										\
																		\
Chunk##NAME::Chunk##NAME( int size, Chunk##NAME *n )					\
: next(n)																\
{																		\
	chunk = new TYPE[size];												\
}																		\
																		\
Chunk##NAME::~Chunk##NAME()												\
{																		\
	delete [] chunk;													\
}																		\
																		\
																		\
																		\
NAME::NAME( int chunksize )												\
: chunkSize(chunksize), numChunks(0),									\
  lastIndex(-1), chunks(NULL), lastChunk(NULL)							\
{																		\
}																		\
																		\
NAME::~NAME()															\
{																		\
	Chunk##NAME *head, *follow;											\
																		\
	destCount++;														\
	head = chunks;														\
	follow = NULL;														\
																		\
	while( head != NULL ) {												\
		follow = head;													\
		head = head->next;												\
		delete( follow );												\
	}																	\
}																		\
																		\
TYPE& NAME::operator[]( int index )										\
{																		\
	Chunk##NAME *curChunk;												\
	int curChunkNumber;													\
																		\
	int chunk = index / chunkSize;										\
	int where = index % chunkSize;										\
																		\
	assert( index <= lastIndex );										\
																		\
	if( chunk == numChunks ) {											\
		return lastChunk->chunk[where];									\
	} else {															\
		curChunk = chunks;												\
		curChunkNumber = 0;												\
																		\
		while( curChunkNumber < chunk ) {								\
			curChunk = curChunk->next;									\
			curChunkNumber++;											\
		}																\
																		\
		return curChunk->chunk[where];									\
	}																	\
}																		\
																		\
void NAME::append( const TYPE& newEl )									\
{																		\
	TYPE& newElement = const_cast<##TYPE&>(newEl);						\
	lastIndex += 1;														\
																		\
	if( lastIndex % chunkSize == 0 ) {									\
		/* we need a new chunk */										\
		numChunks++;													\
																		\
		if( chunks != NULL ) {											\
			lastChunk->next = new Chunk##NAME(chunkSize, NULL);			\
			lastChunk = lastChunk->next;								\
		} else {														\
			chunks = lastChunk = new Chunk##NAME(chunkSize, NULL);		\
		}																\
																		\
		lastChunk->chunk[0] = newElement;								\
																		\
	} else {															\
		/* add it to the last chunk */									\
		int where = lastIndex % chunkSize;								\
		lastChunk->chunk[where] = newElement;							\
	}																	\
}																		\
																		\
void NAME::resize( int newSize )										\
{																		\
	if( newSize > size() ) {											\
																		\
		int curEntries = chunkSize * numChunks;							\
		int newLastChunk = (newSize/chunkSize) + 1;						\
		int numNewChunks = newLastChunk - numChunks;					\
																		\
		numChunks = newLastChunk+1;										\
																		\
		for( int i = 0; i < numNewChunks; i++ ) {						\
			if( chunks != NULL ) {										\
				lastChunk->next = new Chunk##NAME(chunkSize, NULL);		\
				lastChunk = lastChunk->next;							\
			} else {													\
				chunks = lastChunk = new Chunk##NAME(chunkSize,			\
														NULL);			\
			}															\
		}																\
	}																	\
	lastIndex = newSize-1;												\
}																		\
																		\
TYPE& NAME::append()													\
{																		\
	TYPE newT;															\
																		\
	append( newT );														\
																		\
	return (*this)[lastIndex];											\
}																		\
																		\
int NAME::size()														\
{																		\
	return lastIndex+1;													\
}																		\
																		\
																		\
NAME& NAME::operator=( const NAME& other )								\
{																		\
	NAME& rhs = const_cast<NAME&>( other );								\
	int rSize = rhs.size();												\
																		\
	if( chunkSize != rhs.chunkSize ) {									\
																		\
		Chunk##NAME *head, *follow;										\
																		\
		head = chunks;													\
		follow = NULL;													\
																		\
		while( head != NULL ) {											\
			follow = head;												\
			head = head->next;											\
			delete( follow );											\
		}																\
																		\
		chunks = NULL;													\
		chunkSize = rhs.chunkSize;										\
		numChunks = 0;													\
		lastIndex = -1;													\
	}																	\
																		\
	resize( rSize );													\
																		\
	for( int i = 0; i < rSize; i++ ) {									\
		(*this)[i] = rhs[i];											\
	}																	\
																		\
	return (*this);														\
}																		\
																		\
																		\
int NAME::find( char *name,												\
					 int (*compFunc)(##TYPE&, const char *) )			\
{																		\
	int n = size();														\
																		\
	for( int i = 0; i < n; i++ ) {										\
		if( (*compFunc)((*this)[i], name ) == 0 ) {						\
			return i;													\
		}																\
	}																	\
																		\
	return -1;															\
}																		\
																		\
ostream& operator<<( ostream& s, NAME& l )								\
{																		\
	int n = l.size();													\
																		\
	for( int i = 0; i < n; i++ ) {										\
		s << l[i] << ",";												\
	}																	\
																		\
	return s;															\
}																		

#define MimplementPList(TYPE,NAME)										\
																		\
Chunk##NAME::Chunk##NAME( int size, Chunk##NAME *n )					\
: next(n)																\
{																		\
	chunk = new TYPE*[size];												\
}																		\
																		\
Chunk##NAME::~Chunk##NAME()												\
{																		\
	delete [] chunk;													\
}																		\
																		\
																		\
																		\
NAME::NAME( int chunksize )												\
: chunkSize(chunksize), numChunks(0),									\
  lastIndex(-1), chunks(NULL), lastChunk(NULL)							\
{																		\
}																		\
																		\
NAME::~NAME()															\
{																		\
	Chunk##NAME *head, *follow;											\
																		\
	destCount++;														\
	head = chunks;														\
	follow = NULL;														\
																		\
	while( head != NULL ) {												\
		follow = head;													\
		head = head->next;												\
		delete( follow );												\
	}																	\
}																		\
																		\
TYPE*& NAME::operator[]( int index )										\
{																		\
	Chunk##NAME *curChunk;												\
	int curChunkNumber;													\
																		\
	int chunk = index / chunkSize;										\
	int where = index % chunkSize;										\
																		\
	assert( index <= lastIndex );										\
																		\
	if( chunk == numChunks ) {											\
		return lastChunk->chunk[where];									\
	} else {															\
		curChunk = chunks;												\
		curChunkNumber = 0;												\
																		\
		while( curChunkNumber < chunk ) {								\
			curChunk = curChunk->next;									\
			curChunkNumber++;											\
		}																\
																		\
		return curChunk->chunk[where];									\
	}																	\
}																		\
																		\
void NAME::append( const TYPE* newEl )									\
{																		\
	TYPE*& newElement = const_cast<TYPE*&>(newEl);						\
	lastIndex += 1;														\
																		\
	if( lastIndex % chunkSize == 0 ) {									\
		/* we need a new chunk */										\
		numChunks++;													\
																		\
		if( chunks != NULL ) {											\
			lastChunk->next = new Chunk##NAME(chunkSize, NULL);			\
			lastChunk = lastChunk->next;								\
		} else {														\
			chunks = lastChunk = new Chunk##NAME(chunkSize, NULL);		\
		}																\
																		\
		lastChunk->chunk[0] = newElement;								\
																		\
	} else {															\
		/* add it to the last chunk */									\
		int where = lastIndex % chunkSize;								\
		lastChunk->chunk[where] = newElement;							\
	}																	\
}																		\
																		\
void NAME::resize( int newSize )										\
{																		\
	if( newSize > size() ) {											\
																		\
		int curEntries = chunkSize * numChunks;							\
		int newLastChunk = (newSize/chunkSize) + 1;						\
		int numNewChunks = newLastChunk - numChunks;					\
																		\
		numChunks = newLastChunk+1;										\
																		\
		for( int i = 0; i < numNewChunks; i++ ) {						\
			if( chunks != NULL ) {										\
				lastChunk->next = new Chunk##NAME(chunkSize, NULL);		\
				lastChunk = lastChunk->next;							\
			} else {													\
				chunks = lastChunk = new Chunk##NAME(chunkSize,			\
														NULL);			\
			}															\
		}																\
	}																	\
	lastIndex = newSize-1;												\
}																		\
																		\
TYPE*& NAME::append()													\
{																		\
	TYPE* newT;															\
																		\
	append( newT );														\
																		\
	return (*this)[lastIndex];											\
}																		\
																		\
int NAME::size()														\
{																		\
	return lastIndex+1;													\
}																		\
																		\
																		\
NAME& NAME::operator=( const NAME& other )								\
{																		\
	NAME& rhs = const_cast<NAME&>( other );								\
	int rSize = rhs.size();												\
																		\
	if( chunkSize != rhs.chunkSize ) {									\
																		\
		Chunk##NAME *head, *follow;										\
																		\
		head = chunks;													\
		follow = NULL;													\
																		\
		while( head != NULL ) {											\
			follow = head;												\
			head = head->next;											\
			delete( follow );											\
		}																\
																		\
		chunks = NULL;													\
		chunkSize = rhs.chunkSize;										\
		numChunks = 0;													\
		lastIndex = -1;													\
	}																	\
																		\
	resize( rSize );													\
																		\
	for( int i = 0; i < rSize; i++ ) {									\
		(*this)[i] = rhs[i];											\
	}																	\
																		\
	return (*this);														\
}																		\
																		\
																		\
int NAME::find( char *name,												\
					 int (*compFunc)(TYPE*, const char *) )				\
{																		\
	int n = size();														\
																		\
	for( int i = 0; i < n; i++ ) {										\
		if( (*compFunc)((*this)[i], name ) == 0 ) {						\
			return i;													\
		}																\
	}																	\
																		\
	return -1;															\
}																		\
																		\
ostream& operator<<( ostream& s, NAME& l )								\
{																		\
	int n = l.size();													\
																		\
	for( int i = 0; i < n; i++ ) {										\
		s << l[i] << ",";												\
	}																	\
																		\
	return s;															\
}																		
																		
#endif