#ifndef Noise3D_h
#define Noise3D_h

#include "Texture3D.h"

#define TABSIZE 256

/****************************************************************

	Class:		Noise3D
	Purpose:	3d value noise (from Ebert et al.)	

*****************************************************************/
class Noise3D : public Texture3D
{
public:

	Noise3D();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices (none)

	// attribute accessors (none)

	// post read function - initialization
	virtual bool postReadFunc( const Scene& scene );

	// vector/scalar evaluation functions
	virtual vec3 vector();
	virtual double scalar();

protected:

	static unsigned char perm[TABSIZE];		// random permutation table
	static float valueTab[TABSIZE];			// value noise lattice
	static bool init;						// initialized?

	static void valueTabInit(int seed);		// initialize the table
	static float vLattice( int ix, int iy, int iz );	// evalute lattice at specified point

};



#endif