#ifndef PhongShader_h
#define PhongShader_h

#include "LambertShader.h"

class Texture;

/****************************************************************

	Class:		PhongShader
	Purpose:	Implements the Phong shading model	

*****************************************************************/
class PhongShader : public LambertShader
{
public:
	PhongShader();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kSpecularCoeff;
	static int kSpecularColor;
	static int kSpecularExp;

	// attribute accessors
	double attrSpecularCoeff() { return findAttr(kSpecularCoeff)->asDouble(); };
	vec3&  attrSpecularColor() { return findAttr(kSpecularColor)->asVec3(); };
	double attrSpecularExp()   { return findAttr(kSpecularExp)->asDouble(); };

	// compute color method (compute transparency from parent class)
	virtual vec3 computeColor( List<Light *>& lights );

	// set up OpenGL material state
	virtual void setupOGL();
};

#endif

