#include <string.h>
#include "ReadOBJ.h"
#include "List.h"

bool readOBJ( istream& s, Scene& scene, Poly *newPoly )
{
	char line[100];

	List<vec3> vList(1000);
	List<vec3> nList(1000);
	List<vec2> tList(1000);
	List<int> fList(1000);

	List<vec3>& polyVlist = newPoly->local();
	List<vec3>& polyNlist = newPoly->normal();
	List<vec2>& polyTlist = newPoly->texture();
	List<int>& polyFlist = newPoly->face();
	List<int>& polyIlist = newPoly->index();

	vec3 data3;
	vec2 data2;

	int numVertices = 0;
	int numLines = 0;

	while( !s.eof() ) {
		s >> line;
		numLines++;

		if( line[0] == 'u' ) {
			// usemat option, ignore it
			s.getline( line, 100 );

		} else if( line[0] == 'f' ) {
			// read the face
			s.getline( line, 100 );
			char *token;
			int indices[3];
			int i = 0;
			
			polyIlist.append( numVertices );

			token = strtok( line, " /" );
			while( token != NULL ) {
				indices[i++] = atoi( token );

				if( i == 3 ) {
					// we have a point
					//cout << indices[0] << "," << indices[1] << "," << indices[2] << endl;

					if( indices[0] > vList.size() ) {
						cout << "Line " << numLines << "VERT OH SHIT!!!" << endl;
						cout << "Got " << vList.size() << ", want " << indices[0] << endl;
					} 

					if( indices[1] > tList.size() ) {
						cout << "Line " << numLines << "TEX OH SHIT!!!" << endl;
						cout << "Got " << tList.size() << ", want " << indices[1] << endl;
					} 

					if( indices[2] > nList.size() ) {
						cout << "Line " << numLines << "NORM OH SHIT!!!" << endl;
						cout << "Got " << nList.size() << ", want " << indices[2] << endl;
					} 

					polyVlist.append( vList[indices[0]-1] );
					polyTlist.append( tList[indices[1]-1] );
					polyNlist.append( nList[indices[2]-1] );
					polyFlist.append( numVertices++ );

					i = 0;
				}
				token = strtok( NULL, " /" );
			}

		} else if( line[0] == 'v' ) {
			if( line[1] == 't' ) {
				// read texture point
				s >> data2;
				tList.append( data2 );

			} else if( line[1] == 'n' ) {
				// read normal
				s >> data3;
				nList.append( data3 );

			} else {
				// read vertex
				s >> data3;
				vList.append( data3 );
			}

		} else {

			return false;

		}
	}

	polyIlist.append( numVertices );
	return true;
}