#ifndef Sample_h
#define Sample_h

#include "algebra3.h"

/****************************************************************

	Class:		Sample
	Purpose:	Stores information necessary for evaluating 
				shading.

*****************************************************************/
class Sample
{
public:
	Sample();
	Sample( const vec3& worldC, const vec3& worldN, const vec3& eye, const vec3& tex3d, const vec2& tex2d );

	vec3 worldCoords;		// sample point in worldspace
	vec3 worldNormal;		// sample normal in worldspace
	vec3 eye;				// eye point in worldspace
	vec3 texCoords3d;		// 3d texture coordinates
	vec2 texCoords2d;		// 2d texture coordinates
};

#endif