#ifndef Sphere_h
#define Sphere_h

#include "Shape.h"

class Face;

class Sphere : public Shape
{
public:
	Sphere();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kTessLevel;

	// attribute accessors
	int&	attrTessLevel() { return findAttr(kTessLevel)->asInt(); };


	void tessellate( Tessellation& tessellation );
	void localTessellate( TessOptions options, SpaceType space );
	int faceCount();

	void renderOGL();

	virtual void computeBB( const mat4& transform );

private:

	void tessellateRec( Tessellation& tessellation, int *vList, int level );
};

#endif
