#ifndef Texture2D_h
#define Texture2D_h

#include "algebra3.h"
#include "Texture.h"
#include "glut.h"

class Sample;

/****************************************************************

    Class:      Texture2D

	Purpose:	Texture2D is a texture that computes its output
				from the (u,v) coordinates of the sample point.

*****************************************************************/

class Texture2D : public Texture
{
public:
	Texture2D();

	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kTranslate;		// placement translate
	static int kRotate;			// placement rotate
	static int kScale;			// placement scale

	// attribute accessors
	vec2& attrTranslate() { return findAttr(kTranslate)->asVec2(); };
	double& attrRotate()  { return findAttr(kRotate)->asDouble(); };
	vec2& attrScale() { return findAttr(kScale)->asVec2(); };

	// transformation methods
	void updateTransform();

	// get the placement transformation
	mat3& getTransform() { return fTransform; };

protected:

	mat3 fTransform;		// placement matrix
};

#endif

