#ifndef Texture3D_h
#define Texture3D_h

#include "algebra3.h"
#include "Texture.h"
class Sample;

/****************************************************************

	Class:		Texture3D
	Purpose:	Base class for 3d textures	

*****************************************************************/
class Texture3D : public Texture
{
public:
	Texture3D();
	
	// attribute initialization
	virtual void initializeAttributes();

	// attribute indices
	static int kTranslate;		// placement translate
	static int kRotate;			// placement rotate
	static int kScale;			// placement scale

	// attribute accessors
	vec3& attrTranslate() { return findAttr(kTranslate)->asVec3(); };
	vec3& attrRotate()  { return findAttr(kRotate)->asVec3(); };
	vec3& attrScale() { return findAttr(kScale)->asVec3(); };

	// updates placement transform
	void updateTransform();
	mat4& getTransform() { return fTransform; };

protected:

	mat4 fTransform;		// placement transform
};

#endif

