#include "Timer.h"
#include "List.h"
#include <string.h>

Timer::Timer( const char *n ) 
: running(false)
{
	name = new char[strlen(n)+1];
	strcpy( name, n );
	children = new List<Timer *>(2);
}

Timer *Timer::newChild( const char *newName ) 
{ 
	Timer *newTimer = new Timer(newName);
	children->append(newTimer); 
	return newTimer;
}

void printTime( ostream& s, time_t time )
{
	int hours = time / 3600;
	time = time - (hours*3600);

	int minutes = time / 60;
	time = time - (minutes*60);

	int seconds = time;


	if( hours < 10 ) {
		s << "0" << hours;
	} else {
		s << hours;
	}

	s << ":";

	if( minutes < 10 ) {
		s << "0" << minutes;
	} else {
		s << minutes;
	}

	s << ":";

	if( seconds < 10 ) {
		s << "0" << seconds;
	} else {
		s << seconds;
	}
}

void Timer::print( ostream& s, int indent )
{
	for( int j = 0; j < indent; j++ ) {
		s << "    ";
	}

	s << name << ": ";
	printTime( s, elapsed() );

	if( children->size() ) {
		s << " { " << endl;
	} else {
		s << endl;
	}

	for( int i = 0; i < children->size(); i++ ) {
		(*children)[i]->print( s, indent+1 );
	}

	if( children->size() ) {
		for( j = 0; j < indent; j++ ) {
			s << "    ";
		}
		s << "}" << endl;
	}
}

