#ifndef Timer_h
#define Timer_h

#include "time.h"
#include <iostream.h>

template <class T> class List;

class Timer
{
public:
	Timer( const char *name );

	void start() { startTime = time(NULL); running = true; };
	void stop() { stopTime = time(NULL); running = false; };

	time_t elapsed() { return( stopTime - startTime ); };

	Timer *newChild( const char *newName );

	void print( ostream& s, int indent );

private:

	char *name;
	bool running;

	time_t startTime;
	time_t stopTime;

	List<Timer *> *children;
};

#endif