#include <fstream.h>
#include "Scene.h"

// root of the tree of timer probes for the scene
Timer *MainTimer;

void main(int argc, char** argv)
{
	char filename[100];

	if( argc <= 1 ) {
		cout << "Please enter a filename: ";
		cin >> filename;
	} else {
		strcpy( filename, argv[1] );
	}

	ifstream s(filename);
	Scene scene;

	// start the main timing probe
	MainTimer = new Timer( "RenderDude!" );
	MainTimer->start();

	// read the scene
	Timer *readTimer = MainTimer->newChild( "Scene Read" );
	readTimer->start();
	
	bool readStatus = scene.readScene( s );
	
	readTimer->stop();

	if( !readStatus ) {
		cout << "Invalid scene" << endl;
	} else {
		cout << "Face count: " << scene.faceCount() << endl;
		scene.render();
	}

	MainTimer->stop();
	MainTimer->print(cout,0);
}
