/////////////////////////BEGIN CAM.CPP////////////////////////////////////////////


/*
Cam *curCam;
Scene *scenePtr;
BallData *ballData;
int windowX, windowY;
GLenum renderMode = GL_RENDER;
GLuint selectBuf[512];
BallData bd;

vec3 camTrans(0.0);
vec3 curTrans(0.0);

vec2 transDownXY;
vec2 transDownZ;

bool downXY = false;
bool downZ = false;

vec2 tempCamTrans;


void displayOGL( void )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	vec3 trans = 5.0 * (camTrans + curTrans);

	// set up viewing matrix
	float viewMatrix[16];
	Ball_Valuefv( ballData, viewMatrix );

	glPushMatrix();
	glTranslated( trans[VX], trans[VY], trans[VZ] );
	glMultMatrixf(viewMatrix);
	curCam->interactiveRender( *scenePtr, renderMode );
	glPopMatrix();

	if( renderMode == GL_RENDER ) {
		glutSwapBuffers();
	}
}

void pickFunc( int x, int y )
{
	GLint viewport[4];
	GLfloat tform[16];
	int hits;

	glSelectBuffer( 512, selectBuf );


	(void)glRenderMode( GL_SELECT );
	renderMode = GL_SELECT;

	glInitNames();
	glPushName(-1);
	
	glGetIntegerv(GL_VIEWPORT, viewport);

	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();
	gluPickMatrix( (GLdouble)x, (GLdouble)(viewport[3]-y),
					1.0, 1.0, viewport );

	mat4 projTform = curCam->getProjTransform();
	projTform.asFloat( tform );
	glMultMatrixf( tform );

	glMatrixMode( GL_MODELVIEW );

	displayOGL();

	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
	glMatrixMode( GL_MODELVIEW );

	hits = glRenderMode( GL_RENDER );
	renderMode = GL_RENDER;

	curCam->interactivePickFunction( hits, selectBuf );

	displayOGL();
}

void mouseFunc( int button, int state, int x, int y )
{
	if( button == GLUT_LEFT_BUTTON ) {
		if( state == GLUT_DOWN ) {

			if( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) {
				downXY = true;
				transDownXY = vec2((float)x / (float)windowX, 1.0 - ((float)y / (float)windowY) );

			} else {
				HVect now;
				now.x = (float)x / (float)windowX;
				now.y = 1.0f - ((float)y / (float)windowY);

				Ball_Mouse( ballData, now );
				Ball_BeginDrag( ballData );
			}

		} else if( state == GLUT_UP ){

			camTrans[VX] += curTrans[VX];
			camTrans[VY] += curTrans[VY];

			curTrans[VX] = 0.0;
			curTrans[VY] = 0.0;

			downXY = false;
			Ball_EndDrag( ballData );

		}
	} else if( button == GLUT_RIGHT_BUTTON ) {
		if( state == GLUT_DOWN ) {

			if( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) {
				downZ = true;
				transDownZ = vec2((float)x / (float)windowX, 1.0 - ((float)y / (float)windowY) );

			} else {
				// pick something
				pickFunc( x, y );
			}

		} else if( state == GLUT_UP ) {

			camTrans[VZ] += curTrans[VZ];

			curTrans[VZ] = 0.0;

			downZ = false;

		}
	}
}

void mouseMoveFunc( int x, int y )
{
	HVect now;
	now.x = (float)x / (float)windowX;
	now.y = 1.0f - ((float)y / (float)windowY);

	if( downXY ) {
		curTrans[VX] = now.x - transDownXY[VX];
		curTrans[VY] = now.y - transDownXY[VY];
	}

	if( downZ ) {
		curTrans[VZ] = now.x - transDownZ[VX];
	}

	if( !downXY && !downZ ) {

		Ball_Mouse( ballData, now );
		Ball_Update( ballData );
	}

	displayOGL();
}

void keyFunc( unsigned char key, int x, int y )
{
	static bool selecting = false;
	static int whichFace = 0;

	switch( key ) {

	case 'x':
		curCam->postProcess( *scenePtr );
		exit(0);
		break;

	case 'r':
		Ball_Init( &bd );
		camTrans = vec3(0.0);
		curTrans = vec3(0.0);
		displayOGL();
		break;

	case 'p':
		curCam->printSelectedFace();
		break;

	case 's':
		whichFace = 0;
		break;

	default:
		int hits = 1;
		GLuint select[10];
		int cur = key - '0';
		whichFace = whichFace*10 + cur;
		select[0] = 1;
		select[1] = 0;
		select[2] = 0;
		select[3] = whichFace;
		curCam->interactivePickFunction( hits, select );
		displayOGL();
		break;
		
	}
}


void Cam::pushViewTransform(void)
{
	float m[16];
	viewTform.asFloat(m);

	glMultMatrixf(m);
}

void Cam::interactivePreProcess( Scene& scene )
{
	int argc = 1;
	char *argv[1];
	argv[0] = new char[10];
	strcpy( argv[0], "bogus" );

	glutInitWindowSize( (int)imageRes[VX], (int)imageRes[VY] );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_DEPTH );
	glutInit( &argc, argv );
	glutCreateWindow( "Camera" );
	glutDisplayFunc( displayOGL );

	glutKeyboardFunc( keyFunc );

	glutMouseFunc( mouseFunc );
	glutMotionFunc( mouseMoveFunc );

	glEnable( GL_DEPTH_TEST );
	glDepthFunc( GL_LEQUAL );

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	Ball_Init( &bd );
	Quat centre = { 0.5, 0.5, 0.0, 0.0 };
	Ball_Place( &bd, centre, 0.5 );

	windowX = (int)imageRes[VX];
	windowY = (int)imageRes[VY];

	GLfloat tform[16];

	projTform.asFloat( tform );
	glMatrixMode( GL_PROJECTION );
	glLoadMatrixf( tform );

	glMatrixMode( GL_MODELVIEW );
	viewTform.asFloat(tform);
	glLoadMatrixf( tform );

	if( interpolateShading != PERFACE ) {

		// initialize shading
		glShadeModel( GL_SMOOTH );
		glEnable( GL_NORMALIZE );

		// initialize lighting
		glEnable( GL_LIGHTING );
		for( int curLight = 0; curLight < scene.lightList.size(); curLight++ ) {

			int oglLight = GL_LIGHT0 + curLight;
			float vec[4];
			Light*& light = scene.lightList[curLight];

			vec4 worldLight = light->worldPosition();
			GLfloat worldOrigin[] = { worldLight[VX], worldLight[VY], worldLight[VZ], 1.0 };

			glEnable( oglLight );
			light->ambientColor().asFloat( vec );
			glLightfv( oglLight, GL_AMBIENT, vec );

			light->diffuseColor().asFloat( vec );
			glLightfv( oglLight, GL_DIFFUSE, vec );

			light->specularColor().asFloat( vec );
			glLightfv( oglLight, GL_SPECULAR, vec );

			glLightfv( oglLight, GL_POSITION, worldOrigin );
		}

		// initialize textures
		int numTextures = scene.textureList.size();

		for( int curTexture = 0; curTexture < numTextures; curTexture++ ) {
			Texture*& texture = scene.textureList[curTexture];

			if( texture->active() ) {
				texture->interactivePreProcess();
			}
		}

	} else {

		glShadeModel( GL_FLAT );

	}

	scenePtr = &scene; 
	curCam = this;
	ballData = &bd;

	glutMainLoop();
}

void Cam::interactivePostProcess( Scene& scene )
{
	glutDestroyWindow( glutGetWindow() );
}
*/


/////////////////////////END CAM.CPP////////////////////////////////////////////




//////////////////////////////BEGIN CAMHCM.CPP/////////////////////////////////////////////////////
/*



static bool downXY;
static bool downZ;
static bool regionSelect;
static vec2 transDownXY;
static vec2 transDownZ;
static vec2 regionDownXY;
static int windowX, windowY;
static vec2 centre( 256.0, 256.0 );
static double size = 300.0;
static int level = 1;
static int faceList[100];
static int numFaces = 0;
static Tessellation *tessellation;
static List<vec3> *screenPoints;
static bool rd;
static vec4 dr;
static bool rs;
static vec4 sr;
static CoveragePyramid *CP;

void displayOGL2( void ) {

	glClear( GL_COLOR_BUFFER_BIT );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();

	gluOrtho2D( centre[VX]-size, centre[VX]+size, centre[VY]-size, centre[VY]+size );

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	int sizes[4] = { 512, 64, 8, 1 };
	float cols[4][3] = { {1.0f,1.0f,1.0f}, {1.0f,0.0f,0.0f,}, {0.0f,1.0f,0.0f}, {0.0f,0.0f,1.0f} };

	int size = sizes[level];

	glBegin( GL_LINES );
		for( int i = 0; i <= 512; i+=size ) {
	
			for( int l = 1; l <= level; l++ ) {
				if( (i%sizes[l]) == 0 ) {
					float col = 0.25f + 0.25f*(3-l);
					glColor3f( col, col, col );
					break;
				}

			}

			glVertex2d( 0.0, (double)i );
			glVertex2d( 512.0, (double)i );
	
			glVertex2d( (double)i, 0.0 );
			glVertex2d( (double)i, 512.0 );
		}
	glEnd();

	if( rd ) {

		glColor3f( 0.0f, 1.0f, 0.0f );
		glBegin( GL_LINE_LOOP );

			glVertex2f( dr[XL], dr[YL] );
			glVertex2f( dr[XU]+1.0, dr[YL] );
			glVertex2f( dr[XU]+1.0, dr[YU]+1.0 );
			glVertex2f( dr[XL], dr[YU]+1.0 );

		glEnd();

		glBegin( GL_POINTS );
		for( int x = dr[XL]; x <= dr[XU]; x++ ) {
			for( int y = dr[YL]; y <= dr[YU]; y++ ) {

				for( int xx = 0; xx < 8; xx++ ) {
					for( int yy = 0; yy < 8; yy++ ) {

						double px = x + 0.0625 + 0.125 * xx;
						double py = y + 0.0625 + 0.125 * yy;

						glVertex2d( px, py );

					}
				}
			}
		}
		glEnd();


	}

	if( rs ) {

		glColor3f( 1.0f, 0.0f, 0.0f );
		glBegin( GL_LINE_LOOP );

			glVertex2f( sr[XL], sr[YL] );
			glVertex2f( sr[XU], sr[YL] );
			glVertex2f( sr[XU], sr[YU] );
			glVertex2f( sr[XL], sr[YU] );

		glEnd();

	}


	
	for( int j = 0; j < numFaces; j++ ) {
		
		glColor3f( 1.0f, 1.0f, 1.0f );	

		int curFace = faceList[j];

		if( curFace == -1 ) continue;

		int faceSize = tessellation->fList.getListSize(curFace);
		int *vIndices = tessellation->fList.getList(curFace);

		glBegin( GL_LINE_LOOP );
			
			for( int k = 0; k < faceSize; k++ ) {
				 vec3 curPoint = (*screenPoints)[vIndices[k]];
				 glVertex2d( curPoint[VX], curPoint[VY] );
			}

		glEnd();


		glColor3f( 1.0f, 1.0f, 1.0f );
		if( faceSize > 3 ) {

			vec3 v0 = (*screenPoints)[vIndices[0]];

			glBegin( GL_LINES );
				
				for( int t = 2; t <= faceSize-2; t++ ) {
					vec3 curPoint = (*screenPoints)[vIndices[t]];

					glVertex2d( v0[VX], v0[VY] );
					glVertex2d( curPoint[VX], curPoint[VY] );

				}

			glEnd();
		}

	}

	glutSwapBuffers();
}

static void keyFunc( unsigned char key, int x, int y )
{

	switch( key ) {
	case '0':
		level = 0;
		break;
	case '1':
		level = 1;
		break;
	case '2':
		level = 2;
		break;
	case '3':
		level = 3;
		break;

	case 'c':
		{
		bool done = false;
		while( !done ) {
			char cmd[100];

			cout << "[renderer]> ";
			cin >> cmd;

			if( strcmp( cmd, "quit" ) == 0 ) {
				done = true;

			} else if( strcmp( cmd, "r" ) == 0 ) {
				displayOGL2();

			} else if( strcmp( cmd, "add" ) == 0 ) {

				cin >> faceList[numFaces++];
				if( faceList[numFaces] >= tessellation->size() ) {
					cout << "Bad face" << endl;
					faceList[numFaces] = -1;
				}

			} else if( strcmp( cmd, "del" ) == 0 ) {

				int whichFace;
				cin >> whichFace;

				for( int i = 0; i < numFaces; i++ ) {
					if( faceList[i] == whichFace ) {
						faceList[i] = -1;
					}
				}

			} else if( strcmp( cmd, "ls" ) == 0 ) {

				cout << "Displaying faces ";
				for( int i = 0; i < numFaces; i++ ) {
					if( faceList[i] != -1 ) {
						cout << faceList[i] << ", ";
					}
				}
				cout << endl;

			} else if( strcmp( cmd, "p" ) == 0 ) {

				int whichFace;
				cin >> whichFace;

				tessellation->printFace( cout, whichFace, screenPoints );

			} else if( strcmp( cmd, "t" ) == 0 ) {

				int whichFace, whichLevel, x, y;
				Bitmask W, A;
				Triangle curTess[10];

				cin >> whichFace >> whichLevel >> x >> y;

				vec4 imageRange = CP->imageRange( whichLevel, x, y );

				int numTriangles = tessellation->tessellateFace( whichFace, false, (*screenPoints), curTess );

				cout << "*************************************" << endl;
				cout << "Whole face" << endl;
				cout << "*************************************" << endl;

				if( whichLevel == 3 ) {
					Bitmask bm = tessellation->bitMask( whichFace, false, (*screenPoints), imageRange, true  );
					cout << "Mask: " << endl << bm << endl;
				} else {
					TriageMask tm = tessellation->triageMask( whichFace, false, (*screenPoints), imageRange, true );
					cout << "Mask: " << endl << tm << endl;
				}


				for( int whichTri = 0; whichTri < numTriangles; whichTri++ ) {

					cout << "****************************************" << endl;
					cout << "Triangle " << whichTri << endl;
					cout << "****************************************" << endl;


					if( whichLevel == 3 ) {

						Bitmask bm = curTess[whichTri].bitMask( imageRange, true );
						CP->tilePolygon( whichLevel, x, y, TriageMask(bm, ~bm), W, A );

					} else {

						TriageMask tm = curTess[whichTri].triageMask( imageRange, true );
						CP->tilePolygon( whichLevel, x, y, tm, W, A );
					}
				}

			} else if( strcmp( cmd, "s" ) == 0 ) {

					int whichLevel, x, y;

					cin >> whichLevel >> x >> y;
					rs = true;
					sr = CP->imageRange( whichLevel, x, y );


			} else if( strcmp( cmd, "b" ) == 0 ) {

				int level, xL, xH, yL, yH;
				int whichFace;

				cin >> whichFace;

				int faceSize = tessellation->fList.getListSize(whichFace);
				int *vIndices = tessellation->fList.getList(whichFace);

				BoundingBox ssBoundingBox;
				for( int j = 0; j < faceSize; j++ ) {
					ssBoundingBox.expand( (*screenPoints)[vIndices[j]] );
				}

				CP->enclosingSquares( ssBoundingBox, level, xL, xH, yL, yH );

				vec4 low = CP->imageRange( level, xL, yL );
				vec4 high = CP->imageRange( level, xH, yH );

				vec4 box( low[XL], low[YL], high[XU], high[YU] );

				rs = true;
				sr = box;

			} else {
				cout << "Unknown command " << cmd << endl;
			}
		}

		}
		break;

	case 'x':
		exit(0);
		break;
	}

	displayOGL2();
}

static void mouseFunc( int button, int state, int x, int y )
{
	if( button == GLUT_LEFT_BUTTON ) {
		if( state == GLUT_DOWN ) {

			if( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) {

				regionSelect = true;
				regionDownXY = vec2( (double)x, (double)y );

			} else {

				downXY = true;
				transDownXY = vec2( (double)x, (double)y );

			}

		} else if( state == GLUT_UP ){

			if( regionSelect ) {

				cout << "Selecting region " << regionDownXY << " -> " << vec2((double)x, (double)y) << endl;
				regionSelect = false;

			} else {
				downXY = false;
			}

		} else {
			downXY = false;
		}

	} else if( button == GLUT_RIGHT_BUTTON ) {
		if( state == GLUT_DOWN ) {

			downZ = true;
			transDownZ = vec2( (double)x, (double)y );

		} else if( state == GLUT_UP ) {

			downZ = false;

		}
	}
}

static void mouseMoveFunc( int x, int y )
{
	if( downXY ) {

		vec2 dist = vec2((double)x,(double)y) - transDownXY;
		dist[VY] = -dist[VY];

		transDownXY = vec2((double)x,(double)y);

		centre -= dist/(2.0*level);

	} else if( downZ ) {

		
		vec2 dist = vec2((double)x,(double)y) - transDownZ;

		if( dist[VX] != 0.0 ) {
			size -= dist[VX]*(0.1/level);
		}

		size = MAX(size,0.0001);

		transDownZ = vec2( (double)x, (double)y );

	}

	displayOGL2();
}






void setupOGL()
{
	GLfloat amb[] = { 0.2f, 0.2f, 0.2f, 1.0f };
	GLfloat diff[] = { 0.8f, 0.8f, 0.8f, 1.0f };
	GLfloat spec[] = { 0.0f, 0.0f, 0.0f, 1.0f };
	GLfloat shininess = 0.0f;
	GLfloat emiss[] = { 0.0f, 0.0f, 0.0f, 1.0f };
	
	glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, amb );
	glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE, diff );
	glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR, spec );
	glMaterialf( GL_FRONT_AND_BACK, GL_SHININESS, shininess );
	glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, emiss );
}

void CamHCM::interactiveRender( Scene& scene, unsigned int renderMode )
{
	// set up lights
	GLenum lights[] = {GL_LIGHT0, GL_LIGHT1, GL_LIGHT2, GL_LIGHT3, GL_LIGHT4,
					   GL_LIGHT5, GL_LIGHT6, GL_LIGHT7 };
	bool cameraLights = subpixel;

	GLfloat emission[] = {1.0, 1.0, 1.0, 1.0};
	GLfloat emission2[] = {0.0, 0.0, 0.0, 0.0};

	List<Light *>& lightList = scene.lightList;
	int numLights = lightList.size();

	for( int i = 0; i < numLights; i++ ) {

		vec3 worldPos = lightList[i]->worldPosition();
		GLfloat wp[] = { worldPos[VX], worldPos[VY], worldPos[VZ], 0.0 };

		if( cameraLights ) {
			glPushMatrix();
			glLoadIdentity();
		}

		glPushMatrix();

			glTranslatef( wp[0], wp[1], wp[2] );
			glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, emission );
			//auxWireSphere(0.05);
			glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, emission2 );

		glPopMatrix();

		glLightfv( lights[i], GL_POSITION, wp );

		if( cameraLights ) {
			glPopMatrix();
		}
	}

	// render geometry
	srand(0);
	int numFaces = faceOrder->size();

	for( i = 0; i < numFaces; i++ ) {

		int curFace = (*faceOrder)[i];
		int faceStart = tess->pList[2*curFace];
		int faceSize = tess->pList[2*curFace+1];
		int *vIndices = tess->fList.subList(faceStart);

		if( interpolateShading == PERFACE ) {
	
			vec3 curFaceColor;
			curFaceColor[0] = ((double)rand())/RAND_MAX;
			curFaceColor[1] = ((double)rand())/RAND_MAX;
			curFaceColor[2] = ((double)rand())/RAND_MAX;
			curFaceColor.clamp(0.0,1.0);

			if( curFace == selectedFace ) {
				glColor3d( 1.0, 1.0, 1.0 );
			} else {
				glColor3d( curFaceColor[RED], curFaceColor[GREEN], curFaceColor[BLUE] ); 
			}

		} else {

			if( curFace == selectedFace ) {
				GLfloat emission[] = { 1.0, 1.0, 1.0, 1.0 };
				glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, emission );
			} else {
				Shader *shader = tess->sList[curFace]->getShader();
				shader->setupOGL();
			}
		}

		if( renderMode == GL_SELECT ) {
			glLoadName( curFace );
		}

		glBegin( GL_POLYGON );
			for( int v = 0; v < faceSize; v++ ) {
				vec3 curV = tess->vList[vIndices[v]];
				vec2 curT = tess->tList[vIndices[v]];
				vec3 curN;
				
				if( tess->bList[curFace] ) {
					curN = tess->nList[vIndices[v]];
				} else {
					curN = vec3( tess->eList[curFace], VW );
				}

				glTexCoord2f( (GLfloat)(curT[VX]), (GLfloat)(curT[VY]) );
				glNormal3f( (GLfloat)(curN[VX]), (GLfloat)(curN[VY]), (GLfloat)(curN[VZ]) );
				glVertex3f( (GLfloat)(curV[VX]), (GLfloat)(curV[VY]), (GLfloat)(curV[VZ]) );
			}
		glEnd();

		if( (curFace == selectedFace) && (interpolateShading != PERFACE) ) {
			GLfloat emission[] = { 0.0, 0.0, 0.0, 1.0 };
			glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, emission );
		}
	}
}



void CamHCM::interactivePickFunction( int numHits, GLuint *selectBuf )
{
	GLuint *ptr = selectBuf;
	unsigned int minZ = (unsigned int)-1;
	int whichMin = -1;
	char windowTitle[50];

	for( int i = 0; i < numHits; i++ ) {

		assert( ptr[0] == 1 );

		unsigned int mZ = ptr[1];
		int whichFace = ptr[3];

		if( mZ < minZ ) {
			whichMin = whichFace;
			minZ = mZ;
		}
		ptr += 4;
	}

	if( selectedFace == whichMin ) {
		selectedFace = -2;
		sprintf( windowTitle, "Camera" );
	} else {
		selectedFace = whichMin;
		sprintf( windowTitle, "Camera - [Selected face %d]", whichMin );
	}	

	glutSetWindowTitle( windowTitle );
}

void CamHCM::printSelectedFace() 
{
	if( selectedFace >= 0 ) {
		tess->printFace( cout, selectedFace, NULL );

		Triangle tri[MAX_VERTICES];
		int numTris = tess->tessellateFace( selectedFace, false, *ssPoints, tri );
		cout << "Tessellation: " << numTris << " faces..." << endl;
		for( int i = 0; i < numTris; i++ ) {
			cout << "Triangle " << i << ": " << endl << tri[i] << endl;
		}
	}
}


*/

//////////////////////////////END CAMHCM.CPP/////////////////////////////////////////////////////