#include "parseInput.h"
#include <string.h>
#include <ctype.h>

static char lastString[1024];


int parseInput(istream& s, char** vocabulary)
{
	unsigned int i;
	char string[1024];

	// eat whitespace and comments
	eatWS(s);

	if( s.eof() ) return 0;

	// read the text string and force it to uppercase
	strcpy(string, "");
	s >> string;

	for (i=0; i< strlen(string); i++) {
		string[i] = toupper(string[i]);
	}

	// If the string is in the dictionary, return its index
	i = 0;
	while(vocabulary[i]) {

		if (strcmp(vocabulary[i], string) == 0)	{
			break;
		}

		i++;
    }

	if( !vocabulary[i] ) {
		cout << "ERROR: unknown tag " << string << endl;
	}

	strcpy( lastString, string );
	return i+1;
}

void eatWS( istream& s )
{
	char c;	

	while( true ) {

		// eat pure whitespace
		while( !s.eof() && isspace( s.peek() ) ) {
			s.ignore(1);
		}
	
		// return if hit end of file
		if( s.eof() ) return;

		if( s.peek() == EOF ) {
			s >> c;
			return;
		}

		if( s.peek() == '%' ) {
			// read one-line comment
			s.ignore(99999,'\n');
			continue;
		}

		if( s.peek() == '#' ) {
			// multiline comment
			s >> c;
			s.ignore(99999, '#');
			continue;
		}

		// if we get here, it's non-ws input, so return
		return;
	}
}


void putbackLast( istream& s )
{
	for( unsigned int j = strlen(lastString)-1; j != 0; j-- ) {
		s.putback( lastString[j] );
	}
	s.putback( lastString[0] );
}

